
#include <MCP4141.h>



MCP4141::MCP4141(int chipSelect){
  SPI.begin(); 
  SPI.setBitOrder(MSBFIRST);
  cs = chipSelect;
  pinMode(cs, OUTPUT); 
  getPos();
  restorePos(9);
}



void MCP4141::write(byte cmd_byte, byte data_byte)
{
  digitalWrite(cs, LOW);  
  byte high_byte = SPI.transfer(cmd_byte);
  byte low_byte  = SPI.transfer(data_byte);
  digitalWrite(cs, HIGH);
  bool result = ~low_byte;
}

uint16_t MCP4141::read(byte cmd_byte)
{
  digitalWrite(cs, LOW); 
  byte high_byte = SPI.transfer(cmd_byte);
  byte low_byte  = SPI.transfer(0xFF);
  digitalWrite(cs, HIGH);
  return byte2uint16(high_byte, low_byte);
}


uint16_t MCP4141::byte2uint16(byte high_byte, byte low_byte)
{
  return (uint16_t)high_byte<<8 | (uint16_t)low_byte;
}


int  MCP4141::getPos(){
 int pos =   0x01FF &  read(VOLATILE_READ);
 return pos;
}


void MCP4141::setPos(uint16_t pos){
      write(VOLATILE_WRITE, pos);
}


void  MCP4141::inc(){
   write(VOLATILE_INC, 0);
}

void  MCP4141::dec(){
   write(VOLATILE_DEC, 0);
}



 
void  MCP4141::savePos(int num){
     if(num > 9) num =9;
     uint16_t  d = read(B1100);
     write(EEPROM_W[num], d);
  
 }
 

void  MCP4141::restorePos(int num){
     if(num > 9) num =9;
     uint16_t  d = read(EEPROM_R[num]);
     write(VOLATILE_WRITE, d);
 }









 
