#ifndef MCP4141_H
#define MCP4141_H

#include "Arduino.h"
#include "SPI.h" 


 const static uint8_t NONE_VOLATILE_WRITE  = B00100000;
 const static uint8_t NONE_VOLATILE_READ   = B00101100;
 const static uint8_t NONE_VOLATILE_INC    = B00100100;
 const static uint8_t NONE_VOLATILE_DEC    = B00101000;
 const static uint8_t VOLATILE_WRITE  =      B00000000;
 const static uint8_t VOLATILE_READ   =      B00001100;
 const static uint8_t VOLATILE_INC    =      B00000100;
 const static uint8_t VOLATILE_DEC    =      B00001000;
 const static uint8_t STATUS_REG    =      B01011111 ;


 const static uint8_t WP_DIS = B11110100;
 const static uint8_t WP_EN =  B11111000;

                               
 //EEprom write adresses
 const static uint8_t EEPROM_W[] = {B01100000,B01110000,B10000000,B10010000,B10100000,B10110000,B11000000,B11010000,B11100000,B11110000};
 //EEprom read adresses
 const static uint8_t EEPROM_R[] = {B01101111,B01111111,B10001111,B10011111,B10101111,B10111111,B11001111,B11011111,B11101111,B11111111};




class MCP4141{

public:

MCP4141(int cs);
int  getPos();
void inc();
void dec();
void setPos(uint16_t pos);
void  savePos(int num);
void  restorePos(int num);


private:

void write(byte cmd_byte, byte data_byte);
uint16_t read(byte cmd_byte);
uint16_t byte2uint16(byte high_byte, byte low_byte);
int cs; 


};

#endif



